<template>
  <div>
    <mt-page-title :with-border="false" with-padding link-text="retour à l’accueil">
      <h1 class="has-text-weight-bold is-size-3">Informations personnelles</h1>
    </mt-page-title>

    <b-tabs v-model="activeTab" class="mt-carte-utilisateur mt-box-onglet " @change="changeTab">
      <b-tab-item :label="`Mes informations`">
        <mt-fiche-utilisateur>
          <div class="cell-pastille row-3 row-1-mobile is-hidden-mobile">
            <mt-pastille size="43px">{{ utilisateur.initial }}</mt-pastille>
          </div>

          <div class="cell-nom column-2 ">
            <span class="has-text-weight-bold is-size-4">
              <mt-utilisateur :utilisateur="utilisateur" />
            </span>
            <div class="columns mt-profil-list">
              <span
                v-for="userProfil in utilisateur.userProfils"
                :key="`userProfil${userProfil.id}`"
                class="column is-narrow is-capitalized is-size-6"
                >{{ userProfil.profil.description }}</span
              >
            </div>
          </div>

          <div class="cell-flag row-2 is-hidden-mobile">
            <b-icon icon="flag"></b-icon>
          </div>

          <div class="cell-generique column-2-mobile">
            <ul>
              <li v-for="organisme in organismes" :key="organisme.id">
                {{ organisme.libelle }}
              </li>
            </ul>
          </div>

          <div class="cell-generique column-2-mobile">
            <div>{{ utilisateur.email }}<br />{{ utilisateur.telephone }}</div>
            <nuxt-link :to="{ name: 'modifier-infos-persos' }">
              <b-button class="mt-button is-size-8 has-text-weight-semibold" type="is-primary" expanded>
                Modifier mes informations
              </b-button>
            </nuxt-link>
          </div>

          <div class="cell-separateur column-3 is-hidden-mobile">
            <hr />
          </div>

          <div class="column-2 column-1-mobile"></div>

          <div class="cell-generique column-2-mobile">
            <div>Mot de passe <span class="password">&bull;&bull;&bull;&bull;&bull;&bull;&bull;&bull;&bull;</span></div>
            <nuxt-link :to="{ name: 'motdepasse' }">
              <b-button class="mt-button is-size-8 has-text-weight-semibold" type="is-primary" expanded>
                Modifier mon mot de passe
              </b-button>
            </nuxt-link>
          </div>
        </mt-fiche-utilisateur>
      </b-tab-item>
      <b-tab-item :label="'Mes alertes'">
        <mt-fiche-utilisateur-notification :list-notification="lstNotification" />
      </b-tab-item>
      <b-tab-item :label="`Mes statistiques`">
        <mt-fiche-utilisateur-statistique
          :start="start"
          :end="end"
          :type-activite="typeActivite"
          :utilisateur="me"
          :statistique="statistiques"
          @changeDate="changeDate"
        />
      </b-tab-item>
    </b-tabs>
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import userMixin from '~/components/mixins/userMixin';
import MtPastille from '~/components/base/pastille/index';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import MtFicheUtilisateur from '~/components/utilisateur/fiche-utilisateur';
import MtFicheUtilisateurStatistique from '~/components/utilisateur/fiche-utilisateur-statistique';
import MtFicheUtilisateurNotification from '~/components/utilisateur/fiche-utilisateur-notification';

export default {
  components: {
    MtFicheUtilisateurNotification,
    MtFicheUtilisateurStatistique,
    MtFicheUtilisateur,
    MtUtilisateur,
    MtPastille,
    MtPageTitle,
  },
  mixins: [userMixin],
  async asyncData({ $api }) {
    const me = await $api.utilisateurs.me();
    const activeTab = 0;
    const organismes = await $api.organisme(me.affectation.organisme.id).organismesByEnfantOrderByHierarchie();
    const now = new Date();
    const start = DateTime.fromJSDate(now)
      .minus({ year: 1 })
      .toJSDate();
    const end = DateTime.fromJSDate(now).toJSDate();
    const statistiques = await $api.statistiques.statistiqueUtilisateur(
      DateTime.fromJSDate(start).toISO(),
      DateTime.fromJSDate(end).toISO(),
      me.id,
    );
    const typeActivite = await $api.typesActivites.allOrder();
    const lstNotification = await $api.notification.get(me.id);
    return {
      me,
      organismes,
      start,
      end,
      statistiques,
      typeActivite,
      activeTab,
      lstNotification,
    };
  },
  methods: {
    async changeDate({ dateDebut, dateFin }) {
      this.start = dateDebut;
      this.end = dateFin;
      this.statistiques = await this.$api.statistiques.statistiqueUtilisateur(
        DateTime.fromJSDate(dateDebut).toISO(),
        DateTime.fromJSDate(dateFin).toISO(),
        this.me.id,
      );
    },
    async changeTab() {
      if (this.activeTab === 1) {
        this.statistiques = await this.$api.statistiques.statistiqueUtilisateur(
          DateTime.fromJSDate(this.start).toISO(),
          DateTime.fromJSDate(this.end).toISO(),
          this.me.id,
        );
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-carte-utilisateur {
  border-radius: $border-radius;
  box-shadow: 0 2px 8px -1px rgba(102, 110, 232, 0.2);
  background-color: $white;
}
@media (max-width: 768px) {
  .mt-carte-utilisateur {
    padding-left: 0.5rem;
  }
}
</style>
